/// <reference types="react" />
declare type Renderer<RR, RO = undefined> = (ui: React.ReactElement, options?: RO) => RR;
export declare class Kit<RR, RO, P, E = {}, F = {}, A = {}> {
    private render;
    private component;
    private defaultProps;
    static create<RR, RO, P>(render: Renderer<RR, RO>, component: React.ComponentType<P>, defaultProps: () => P): Kit<RR, RO, P, {}, {}, {}>;
    static withRender<WRR, RO>(render: Renderer<WRR, RO>): {
        create<CP>(component: import("react").ComponentType<CP>, defaultProps: () => CP): Kit<WRR, RO, CP, {}, {}, {}>;
    };
    private elements?;
    private fire?;
    private async?;
    protected constructor(render: Renderer<RR, RO>, component: React.ComponentType<P>, defaultProps: () => P);
    setElements<NE extends E>(elements: (renderResult: RR) => NE): Kit<RR, RO, P, NE, F, A>;
    setFire<NF extends F>(fire: (renderResult: E) => NF): Kit<RR, RO, P, E, NF, A>;
    setAsync<NA extends A>(async: (e: E) => NA): Kit<RR, RO, P, E, F, NA>;
    run(overrides?: Partial<P>, renderOptions?: RO): RunInstance<P & Partial<P>, RR, E, F, A>;
}
declare class RunInstance<P, Q, E, F, A> {
    props: P;
    queries: Q;
    elements: E;
    fire: F;
    waitFor: A;
    constructor(props: P, queries: Q, elements: E, fire: F, waitFor: A);
}
export {};
