(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (global = global || self, factory(global.reactTestingKit = {}, global.react));
}(this, (function (exports, react) {
  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  var Kit =
  /*#__PURE__*/
  function () {
    function Kit(render, component, defaultProps) {
      this.render = render;
      this.component = component;
      this.defaultProps = defaultProps;
    }

    Kit.create = function create(render, component, defaultProps) {
      return new Kit(render, component, defaultProps);
    };

    Kit.withRender = function withRender(render) {
      return {
        create: function create(component, defaultProps) {
          return Kit.create(render, component, defaultProps);
        }
      };
    };

    var _proto = Kit.prototype;

    _proto.setElements = function setElements(elements) {
      var kit = new Kit(this.render, this.component, this.defaultProps);
      kit.elements = elements;
      kit.fire = this.fire;
      kit.async = this.async;
      return kit;
    };

    _proto.setFire = function setFire(fire) {
      var kit = new Kit(this.render, this.component, this.defaultProps);
      kit.elements = this.elements;
      kit.fire = fire;
      kit.async = this.async;
      return kit;
    };

    _proto.setAsync = function setAsync(async) {
      var kit = new Kit(this.render, this.component, this.defaultProps);
      kit.elements = this.elements;
      kit.fire = this.fire;
      kit.async = async;
      return kit;
    };

    _proto.run = function run(overrides, renderOptions) {
      var _ref, _this$elements, _ref2, _this$fire, _ref3, _this$async;

      if (overrides === void 0) {
        overrides = {};
      }

      var props = _extends({}, this.defaultProps(), overrides);

      var queries = this.render(react.createElement(this.component, props), renderOptions);
      var elements = (_ref = (_this$elements = this.elements) == null ? void 0 : _this$elements.call(this, queries)) != null ? _ref : {};
      var fire = (_ref2 = (_this$fire = this.fire) == null ? void 0 : _this$fire.call(this, elements)) != null ? _ref2 : {};
      var waitFor = (_ref3 = (_this$async = this.async) == null ? void 0 : _this$async.call(this, elements)) != null ? _ref3 : {};
      return new RunInstance(props, queries, elements, fire, waitFor);
    };

    return Kit;
  }();

  var RunInstance = function RunInstance(props, queries, elements, fire, waitFor) {
    this.props = props;
    this.queries = queries;
    this.elements = elements;
    this.fire = fire;
    this.waitFor = waitFor;
  };

  exports.Kit = Kit;

})));
//# sourceMappingURL=react-testing-kit.umd.js.map
